#include "stm32f4xx.h"
#include "stdint.h"
#include "RPM_Encoder.h"
#include "delay.h"
const int AF02=0x02;
volatile uint64_t first, second, dir;
float frequency;
float time;
void Encoder_init(uint16_t max_count)
	{
	RCC->APB1ENR|=RCC_APB1ENR_TIM3EN;
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOBEN;

	/*GPIO B configuration for timer mode */
	GPIOB->MODER|=GPIO_MODER_MODE4_1|GPIO_MODER_MODE5_1;
	GPIOB->MODER&=~(GPIO_MODER_MODE4_0|GPIO_MODER_MODE5_0);
	GPIOB->AFR[0]|=(AF02<<16)|(AF02<<20);

	/*Timer configuration for encoder mode */
	TIM3->ARR = max_count; //set the max count
	/*Timer in encoder mode*/
	TIM3->CCMR1 |= (TIM_CCMR1_CC1S_0 | TIM_CCMR1_CC2S_0 );
	TIM3->CCER &= ~(TIM_CCER_CC1P | TIM_CCER_CC2P);
	TIM3->SMCR |= TIM_SMCR_SMS_0 | TIM_SMCR_SMS_1;
	/*Enable interrupt*/
	TIM3->DIER|=TIM_DIER_UIE;
	NVIC_EnableIRQ(TIM3_IRQn);
	/*Start the timer */
	TIM3->CR1|=TIM_CR1_CEN;

	}



float get_rpm()
	{
	time=(time/1000); /*from microseconds to seconds*/
	if(0==time)return 0;
	frequency=1/time;
	return frequency*60;
	//return TIM3->CNT;
	}

void TIM3_IRQHandler(void)
	{

	if(TIM_SR_UIF&&TIM3->SR)
		{
		if(dir==1)
			{
			time=millis()-first;
			dir=0;
			}
		else {
			first =millis();
			dir=1;
			}

		TIM3->SR&=~TIM_SR_UIF;
		}
	}
