#include "stepper_motor.h"
#include "stm32f4xx.h"
uint32_t frequency_step;
void stepper_init(uint32_t freq)
	{
	#define TIM2_AF 0x01
	frequency_step=freq;
	RCC->AHB1ENR	|=	RCC_AHB1ENR_GPIOAEN;
	GPIOA->MODER	|=	GPIO_MODER_MODE0_1;
	GPIOA->MODER	&= ~GPIO_MODER_MODE0_0;
	GPIOA->MODER	|= GPIO_MODER_MODE1_0;
	GPIOA->AFR[0] |= (TIM2_AF<<0);

	RCC->APB1ENR  |=  RCC_APB1ENR_TIM2EN;
	TIM2->CR1     &=~ TIM_CR1_CEN;
	TIM2->CCMR1|=TIM_CCMR1_OC1M_2|TIM_CCMR1_OC1M_1;
	TIM2->CCER|=TIM_CCER_CC1E;
	TIM2->PSC=40000;
	TIM2->ARR=10;
	TIM2->CCR1=5;
	}

void stepper_motor_start()
	{
	TIM2->CR1     |= TIM_CR1_CEN;
	for(int i=40000;i>frequency_step;i--)
						{
						TIM2->PSC=i;
						for(int j=0;j<100;j++);
						}
	}

void stepper_motor_stop()
	{
	TIM2->CR1     &=~ TIM_CR1_CEN;
	}

void stepper_motor_clockwise()
	{
	GPIOA->ODR|=GPIO_ODR_OD1;
	}


void stepper_motor_counter_clockwise()
	{
	GPIOA->ODR&=~GPIO_ODR_OD1;
	}
